/* ----------------------------------------- */
/* --- I2C LEDKEY Controller                 */
/*                  released by fumi2kick.   */
/*                 programmed by rerofumi.   */
/* ----------------------------------------- */

#include <device.h>
#include "i2c_ledkey_controll.h"

/* --- define */
static const uint8 LEDKEY_I2C_ADDRESS = 0x2e;

/* --- buffer */
static uint8 led_pwm[9];


uint8 fmLedKeyI2CWaitComplete(void)
{
	uint8 result = I2C_1_MSTAT_XFER_INP;

	while(result == I2C_1_MSTAT_XFER_INP) {
		result = I2C_1_MasterStatus();
	}

	if ((result == I2C_1_MSTAT_RD_CMPLT) ||
		(result == I2C_1_MSTAT_WR_CMPLT)) {
		result = 0;
	}
	return result;
}


void fmLedKeyInitialize(void)
{
	uint8 i;
	for(i=0; i<9; i++) {
		led_pwm[i] = 0;
	}
	fmLedKeySendLed();
}


void fmLedKeySendLed(void)
{
	led_pwm[0] = 0xff;
	
	I2C_1_MasterClearStatus();
	I2C_1_MasterWriteBuf(LEDKEY_I2C_ADDRESS, led_pwm, 9, I2C_1_MODE_COMPLETE_XFER);
	fmLedKeyI2CWaitComplete();
}


uint8 fmLedKeyGet(void)
{
	uint8 keybit;
	keybit = 0;

	I2C_1_MasterClearStatus();
	I2C_1_MasterReadBuf(LEDKEY_I2C_ADDRESS, &keybit, 1, I2C_1_MODE_COMPLETE_XFER);
	fmLedKeyI2CWaitComplete();

	return keybit;
}


void fmLedKeySetLight(uint8 position, uint8 pow)
{
	if (position > 8) {
		return;
	}
	
	led_pwm[position+1] = pow;
}

