#include <device.h>
#include "i2c_ledkey_controll.h"

static uint8 led[8];
static uint8 mode, inkey, postkey, bitkey;
static uint8 counter;
static uint8 position;


/* ---------------------------------------------------- */
/* --- demo animation work */
void fade(void)
{
	uint8 i;
	for(i=0; i<8; i++) {
		if (led[i] > 0) {
			if (led[i] > 6) {
				led[i] -= 6;
			}
			else {
				led[i] = 0;
			}
		}
	}
}


void demo1(void)
{
	uint8 timing;
	timing = counter >> 3;
	if (timing < 8) {
		led[timing] = 0xff;
	}
	if ((timing >= 16) && (timing < 24)) {
		led[7-(timing-16)] = 0xff;
	}
	fade();
}


void demo2(void)
{
	uint8 nowpos, key;
	
	if (inkey == 0) {
		nowpos = position;
	}
	else {
		key = inkey;
		for(nowpos=0; nowpos<8; nowpos++) {
			if (key & 1) {
				break;
			}
			key >>= 1;
		}
	}
	
	if (counter > 8) {
		counter = 0;
		if (position > nowpos) {
			position -= 1;
		}
		if (position < nowpos) {
			position += 1;
		}
	}
	led[position] = 0xff;
	fade();
}


void demo3(void)
{
	uint8 i, k;

	k = inkey;
	for(i=0; i<8; i++) {
		if (k & 1) {
			led[i] = 0xff;
		}
		k >>= 1;
	}
	
	/* triger reverse */
	k = (inkey ^ postkey) & inkey;
	bitkey ^= k;

	postkey = inkey;
	fade();
	k = bitkey;
	for(i=0; i<8; i++) {
		if ((k & 1) && (led[i] < 0x40)) {
			led[i] = 0x40;
		}
		k >>= 1;
	}
}




/* --- interface */
void demoInitialize(void)
{
	uint8 i;
	for(i=0; i<8; i++) {
		led[i] = 0;
	}
	counter = 0;
	position = 0;
	postkey = 0;
	bitkey = 0;
}


void demoSelect(uint8 reqmode)
{
	mode = reqmode;
	if (mode > 2) {
		mode = 0;
	}
}


void demoTick(void)
{
	uint8 i;

	switch(mode)
	{
	case 0:
		demo1();
		break;
		
	case 1:
		demo2();
		break;

	case 2:
		demo3();
		break;

	default:
		demo1();
		break;
	}
	counter += 1;
	
	for(i=0; i<8; i++) {
		fmLedKeySetLight(i, led[i]);
	}
}

void demoInkey(uint8 key)
{
	inkey = key;
}


