/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <device.h>
#include "i2c_ledkey_controll.h"
#include "ledkey_demo1.h"


/* --- Global value */
static unsigned char g_counter;


/* --- Interrupt */
void my_isr_timer1(void) 
{
	if (g_counter > 0) {
		g_counter -= 1;
	}
}

/* --- 10ms wait */
void wait_sync(uint8 time)
{
	g_counter = time;
	while(g_counter > 0) {};
}

/* -------------------------------------------- */
/* --- main routine */
void main()
{
	uint8 count, inkey;
	uint8 mode;

	Timer_1_Start();
	isr_1_Start();
	I2C_1_Start();
	I2C_1_EnableInt();

    CYGlobalIntEnable;
	
	fmLedKeyInitialize();
	count = 0;
	mode = 0;
	demoSelect(mode);
	demoInitialize();

    for(;;)
    {
		inkey = fmLedKeyGet();
		if (inkey == 0x81) {
			mode = (mode + 1) % 3;
			demoSelect(mode);
			demoInitialize();
			while((inkey = fmLedKeyGet()) != 0) {
				wait_sync(1);
			}
		}
		demoInkey(inkey);
		
		/* --- */
		demoTick();
		fmLedKeySendLed();
		count += 1;
        wait_sync(1);
    }
}

/* [] END OF FILE */
